/**********************************************************************
 *		Low Level IO for WinCE (ƏȂ񂾂)
 **********************************************************************
 */

#include <stdio.h>
#include <stat.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/xunistd.h>

#include "conslib.h"

#define	DEBUG	0

/**********************************************************************
 *		
 **********************************************************************
 */
static char *convpath(char *t,char *s)
{
	char *r = t;
	while(*s) {
		if(*s =='/' ) *t++ = '\\';
		else *t++ = *s;
		
		s++;
	}
	*t=0;
	return r;
}

static int new_handle(void)
{
	struct _handles *h=_fddb;		/* ᐅt@Cnh */
	int i;
	for(i=0;i<OPEN_MAX;i++,h++) {
		if(h->inuse == _FD_NOTUSED) return i;	/* 0 : free file handles */
	}
	return (-1);
}

int _open (const char *fname, int fd, int mode)
{
    struct _handles *lp = &_fddb[fd];

    /* \̂̓eNA */
    memset (lp, '\0', sizeof (struct _handles));

    /* handles \̂쐬 */
    lp->inuse = _FD_APPLICATION;
    lp->unlink = 0;
    lp->oflag = mode;
    lp->cdev = lp->iomd & _DEV_CDEV;

    /* ΃pXL */
//    strcpy (lp->abspath, fname);

    /* ߂ */
    return 0;
}

int open (char *filename, int access , unsigned mode)
{
	int createf=OPEN_EXISTING;
	int writef =GENERIC_READ;
	char name[256];
	LPTSTR tbuf[256];
	LPTSTR abuf[256];
	int fd;
    struct _handles *f;

	fd = new_handle();
	if( fd == (-1) ) return -1;
	f = &_fddb[fd];
	
	switch( access & 3 ) {
	  case O_RDONLY:	writef =GENERIC_READ ;				break;
	  case O_RDWR:		writef =GENERIC_READ |GENERIC_WRITE;break;
	  case O_WRONLY:	writef =GENERIC_WRITE;				break;
	  default:		return (-1);
	}
	if( access & O_CREAT) createf=CREATE_ALWAYS;

	sjis2TCHAR( convpath(name,filename) ,tbuf,510 );
	rel2absdir( abuf,256,tbuf );

#if	DEBUG
	errprintf("feopn: CreateFile: writef=%d createf=%d\n",writef,createf);
	
	errprintf("tbuf=[");
	Cputs(tbuf);
	errprintf("]\nabuf=[");
	Cputs(abuf);
	errprintf("]\n");
#endif

	f->CEhandle = (int)CreateFile( abuf, writef, FILE_SHARE_READ, NULL,
						 		   createf,FILE_ATTRIBUTE_NORMAL, 0 ) ;

#if	DEBUG
	errprintf("feopn: CreateFile=%d:\n",f->CEhandle);
#endif

	if ( f->CEhandle == INVALID_HANDLE_VALUE ) {
#if	DEBUG
		errprintf("feopn: CreateFile ERR\n");
#endif
		return (-1) ;
	}
	if( access & O_TRUNC ) { SetEndOfFile(   f->CEhandle ); }
	if( access & O_APPEND ) {SetFilePointer( f->CEhandle, 0, NULL, FILE_END ); }

//	if(mode[0]=='r') f->flags =(_F_READ|_F_BUF|_IOFBF);
//	else		 	 f->flags =(_F_WRIT|_F_BUF|_IOFBF);

	return fd;
}

int read (int fileno, char *buffer, unsigned int bytes)
{
    struct _handles *f = & _fddb[fileno];
	int donesize=(-1);
	int r;

	if(f->ttyflg) {
		return 0;
	}else{
		r = ReadFile( f->CEhandle, buffer , bytes , &donesize , NULL ) ;
		return donesize;
	}
}

#define	C_(n) ((n)-0x40)

int write (int fileno, const char *buffer, unsigned int bytes)
{
    struct _handles *f = & _fddb[fileno];
	int donesize=(-1);
	int brk;
	int r;
	char  abuf[BUFSIZ];
	TCHAR Tbuf[BUFSIZ+1];

	if(f->ttyflg) {
		memcpy(abuf,buffer,bytes);
		abuf[bytes]=0;
		sjis2TCHAR( abuf,Tbuf,BUFSIZ );
		Cputs( Tbuf );
#if	1	//o͒ ^C  ^S ̎󂯕t.
			if( Kbhit() ) {
				brk = Getch();
				if(brk == C_('S')) {	// ^S󂯂AɂP҂.
					brk = Getch();
				}
				if(brk == C_('C')) exit(11);	// ^C Ȃ甲.
			}
#endif
		return bytes;
	}else{
		r = WriteFile( f->CEhandle, buffer , bytes , &donesize , NULL ) ;
		return donesize;
	}
}
int lseek (int fileno, long offset, int whence)
{
}
int close (int fileno)
{
    struct _handles *f = & _fddb[fileno];
	CloseHandle( f->CEhandle );
}
int isatty(int fileno)
{
    struct _handles *f = & _fddb[fileno];
    return f->ttyflg;
}

/**********************************************************************
 *		
 **********************************************************************
 */
int dosgetc(FILE *f)
{
	int c;
	c=fgetc(f);
	if(	c=='\r') {	// CR 폜.
		c=fgetc(f);
	}
	return c;
}
/**********************************************************************
 *		߂l̓Rs[ĎgƁBiobt@PȂ̂Łj
 **********************************************************************
 */
char *getenv(const char *name)
{
#if	0
	static char val[256];
	int r;
	r = GetEnvVar(name,val,256);
	if(r) return val;
#endif
	return NULL;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int  fstat(int handle, struct stat *statbuf)
{
	BY_HANDLE_FILE_INFORMATION info;
    struct _handles *f = & _fddb[handle];

	if ( GetFileInformationByHandle((HANDLE) f->CEhandle, &info) == TRUE) {
		statbuf->st_size = info.nFileSizeLow;
		return 0;
	}
	return -1;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int  stat(const char *path, struct stat *statbuf)
{
	FILE *fp;
	int rc;
	fp = fopen(path,"rt");
	if(fp==NULL) return -1;
	rc = fstat(fileno(fp),statbuf);
	fclose(fp);
	return rc;
}
