/**********************************************************************
 *		
 **********************************************************************
 */
#include	"conslib.h"
#include	<tchar.h>
#include	<setjmp.h>
#include	"stdio.h"

FILE *set_redirect(FILE *fp,char *filename,char *mode);
char *xstrdup(char *string);
void celib_init(void);
int  main( int argc, char *argv[]);
int sjis2TCHAR( const BYTE *src, LPTSTR dst, DWORD max );
int	errprintf(char *fmt,... );
/**********************************************************************
 *		
 **********************************************************************
 */
TCHAR	AppName[] = TEXT("Console") ;	/* K{ */

#define	MAXARGS	1024
#define	WILD_ARGS

#define	PIPEFILE1	"\\windows\\pipe.$$$"
#define	PIPEFILE2	"\\windows\\pipe1.$$$"

static int    Margc;
static char  *Margv[MAXARGS];
static int	  pipearg0 = 0;
static int    pipeflag = 0;
static char  *pipefile=PIPEFILE1;

static DWORD unicode2sjis( LPCTSTR src, BYTE *dst, DWORD max )
{
	return WideCharToMultiByte( CP_ACP, 0, src, -1, dst, dst ? max : 0, NULL, NULL ) ;
}
static char *u2a(TCHAR *src)
{
	static char u2abuf[_MAX_PATH];
	unicode2sjis( src,u2abuf,_MAX_PATH );
	return u2abuf;
}


/* ChJ[h̓WJsȂ */
#ifdef WILD_ARGS

extern	char	wildargs;	//R}hC̃ChJ[h
							//t@CɓWJꍇ́A̕ϐ
							//AvP[V 1  2 
							//ݒ肷. 2ɂꍇ͑WJ
							//ȂݒɂȂ(ꓖIŕsi).

static	HANDLE 			wild_ffh;
static	WIN32_FIND_DATA	wild_fd;
static  int   wild_cnt=0;
static	TCHAR wild_path[_MAX_PATH];
/**********************************************************************
 *		
 **********************************************************************
 */
static int is_wild(char *s)
{
	while(*s) {
		if( (*s=='*')||(*s=='?') ) return 1;
		s++;
	}
	return 0;
}

static void setfiles(char *s)
{
	TCHAR Tpath[_MAX_PATH];

	sjis2TCHAR( s , Tpath ,_MAX_PATH );
	rel2absdir(wild_path ,_MAX_PATH, Tpath ) ;//΃pX΃pX.
	wild_cnt = 0;
}

static int filesSub(char *buf)
{
	if (wild_cnt < 0) return 0;
	
	if (wild_cnt == 0) {
		wild_ffh = FindFirstFile(wild_path , &wild_fd );
		if ( wild_ffh != INVALID_HANDLE_VALUE ) {
			unicode2sjis(wild_fd.cFileName,buf ,_MAX_PATH);
			wild_cnt ++;
			return 1;
		}else{
			wild_ffh = INVALID_HANDLE_VALUE;
			wild_cnt = -1;
			return 0;
		}
	}else{
		if( FindNextFile( wild_ffh, &wild_fd ) ) {
			unicode2sjis(wild_fd.cFileName,buf ,_MAX_PATH);
			wild_cnt ++;
			return 1;
		}else{
			wild_ffh = INVALID_HANDLE_VALUE;
			wild_cnt = -1;
			return 0;
		}
	}
}

static int files(char *buf)
{
	while(filesSub(buf)) {
		if( (wild_fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )== 0) return 1;
	}
	return 0;
}

#endif
/**********************************************************************
 *		
 **********************************************************************
 */
static int expand_redir(int targs,LPTSTR targv[])
{
	char abuf[_MAX_PATH];
	char namebuf[_MAX_PATH];
	char *s;
	char *openmode;
	int  i,c;

    /* _CNg𒲂ׂ. */
    i=0;

    while (i < targs) {
#if	0
        s = targv[i++];
#else
		unicode2sjis(targv[i++],abuf,_MAX_PATH);
		s = abuf;
#endif
        if(*s == '>') {
            if(s[1]=='>') {s++;openmode="at";}	// 
            else          {    openmode="wt";}	// 
            if(s[1]) {
                if(set_redirect(stdout,s+1 ,openmode)==NULL) return 1;
            }else{
				unicode2sjis(targv[i++],abuf,_MAX_PATH);
                if(set_redirect(stdout,abuf,openmode)==NULL) return 1;
            }
        }else
        if(*s == '<') {
            if(s[1]) {
                if(set_redirect(stdin,s+1 ,"rt")==NULL) return 1;
            }else{
				unicode2sjis(targv[i++],abuf,_MAX_PATH);
                if(set_redirect(stdin,abuf,"rt")==NULL) return 1;

                if(	strcmp(abuf,pipefile)==0) {	
                	//_CNgECꂽt@C
                	//pipefileƓꂾApipefileʂ̕ɂ.
					//ipipeĂAOpipeƏՓ˂Ȃ
					//܂.
                	pipefile = PIPEFILE2;
                }

            }
        }else
        if(*s == '|') {
        	pipeflag = 1;
        	pipearg0 = (i-1);
			if(set_redirect(stdout,pipefile ,"wt")==NULL) return 1;
			break;
        }else{
	/* ChJ[h̓WJsȂ */
#ifdef WILD_ARGS
            if( is_wild(s) && (Margc >= wildargs ) && wildargs ) {   //ChJ[h̓WJ
                             //~~~~~~~~~~~~~~~~~~ ȂgcL[Ƃꓖ.
				int cnt=0;
                setfiles(s);
                while(files(namebuf)) {
                    Margv[Margc++] = xstrdup(namebuf);cnt++;
                }

				if(cnt==0) {
#if	0
                    printf("[%s]Ƀ}b`t@C͂܂.",s);
                    return (1);
#else
					Margv[Margc++] = xstrdup(s);
#endif
                }
            }else
#endif
            {
	/* ChJ[hłȂ͂̂܂ */
		c=*s;
		if( (c=='\'')||(c=='\"') ) {
		    if(s[strlen(s)-1]==c) {
		       s[strlen(s)-1]=0;
		       s++;
		    }
		}
                Margv[Margc++] = xstrdup(s);
            }
        }
    }
	Margv[Margc]=NULL;            /* ʖډ */
	return 0;
}

static TCHAR *Tcharcat(TCHAR *t,char *s)
{
	int n;
	n = sjis2TCHAR(s,t,_MAX_PATH) - 2;
	n >>= 1;
	return t + n;
}

static TCHAR *Tcharcat2(TCHAR *t,TCHAR *s)
{
	while(*s) { *t++ = *s++; }
	*t = 0;
	return t;
}

void pipe_exec(DWORD targc, LPTSTR targv[],int pipec)
{
	char   exefile[256];	// +1 oCgڂAst@C.
	TCHAR Texefile[256];

	char   cmdline[512];
	TCHAR Tcmdline[512];
	TCHAR *Tp;
	int i;


	// argc,argv | ꂽꏊ܂ł炷.
	targv += pipec;
	targc -= pipec;

	unicode2sjis(targv[0],exefile,_MAX_PATH);	
	if(exefile[1]==0) {	// | Ǝ̃R}hĂ.
		targc--;
		targv++;
		if(targc>=1) {	// | ̎ɃR}hƃp[^Ă.
			unicode2sjis(targv[0],exefile+1,254);
		}else{			// | ŏIĂ.(̂.)
			// | ŏIĂꍇAlessN()
			strcpy(exefile+1,"less");
		}
	}

	// sR}ȟ " < pipefile" }.
	Tp =  Tcmdline;
	Tp =  Tcharcat(Tp,"< ");
	Tp =  Tcharcat(Tp,pipefile);

	// sR}hɑp[^u.
	for(i=1;i<(int)targc;i++) {
		Tp = Tcharcat(Tp," ");
		Tp = Tcharcat2(Tp,targv[i]);
	}
	{
		unicode2sjis(Tcmdline,cmdline,511);
#ifdef	DEBUG
		errprintf("%s=%s\n",exefile+1,cmdline);
#endif
	}

	{
		sjis2TCHAR(exefile+1,Texefile,_MAX_PATH);
		if ( !ExecuteProcess( Texefile , Tcmdline ) ) {
			errprintf("Can't exec: %s %s\n",exefile,cmdline);
		}
	}
}


/**********************************************************************
 *  exit()̑
 **********************************************************************
 */
static  jmp_buf jumper;
static	int		exit_code = 0;

void cwin_exit( int rval )
{
	exit_code = rval;
    longjmp( jumper , 1 );
}

/**********************************************************************
 *		
 **********************************************************************
 */
int Main( DWORD targc, LPTSTR targv[] )
{
	int retval ;
	celib_init();
	expand_redir(targc,targv);

    retval = setjmp( jumper );	/* exit()΍ */
    if(retval == 0) {			/* setjmp[ȊOȂlongjumpĂƂ*/
        exit_code = main(Margc,Margv);        /* ʂ main() Ăяo */
    }

	fclose(stderr);
	fclose(stdout);

	if(pipeflag) {
		pipe_exec(targc,targv,pipearg0);
	}

	return exit_code;
}
