//
//	E\ stdio.h .
//
#include <stdarg.h>

typedef struct	{
	int     	flags;		/* tOrbg          	       */
	int 		fd;			/* WinCẼt@Cnh         */

	unsigned char *buffer;	/* Xg[Eobt@            */
	unsigned char *curp;	/* [̓ǂݏ|C^    */
	unsigned char *eofp;	/* [̓ǂݍݎ|C^̍ŏIʒu */
	unsigned char *endp;	/* [̏ݎ|C^̍ŏIʒu */
	int 		bsize;		/* Xg[Eobt@̊mۃTCY         */
	int			level;		/* Xg[Eobt@̎gpoCg       */

	char  		token;		/* FILE\̂gpȂ...1      */
	char  		istty;		/* TTY INȂ1 OUTȂ2 t@C=0 */
	char		hold;		/* ungetc()pz[hobt@      */
	char		iobuf;		/* _IOFBF/_IOLBF			       */
}	FILE;

#define _IOFBF       0x0000
#define _IOLBF       0x0001
#define _IONBF       0x0002
#define _IOBMASK     0x0003

#define _IOREAD      0x0004
#define _IOWRITE     0x0008
#define _IOAPPEND    0x0010
#define _IOTRUNC     0x0020
#define _IOCREAT     0x0040
#define _IOBIN       0x0080
#define _IOFREE      0x0100
#define _IOEOF       0x0200
#define _IOERR       0x0400
#define _IOR         0x0800
#define _IOW         0x1000
#define _IOAPPLS     0x2000
#define _IOEMU       0x4000
#define _IOUPD       (_IOREAD | _IOWRITE)

#define EOF		(-1)			/* End of file indicator */

#ifndef	NULL
#define	NULL		0
#endif

#define BUFSIZ	4096			/* Buffer size for stdio */

#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2

extern	FILE	_streams[];

#define stdin	(&_streams[0])
#define stdout	(&_streams[1])
#define stderr	(&_streams[2])

typedef unsigned size_t;

int	  fclose (FILE *fp);
int	  fflush (FILE *fp);
int	  fgetc	 (FILE *fp);
char *fgets	 (char *s, int n, FILE *fp);
FILE *fopen	 (const char *filename, char *mode);
int	  fputc	 (char c, FILE *fp);
int	  fputs	 (char *s, FILE *fp);
int	  fread	 (void *ptr, unsigned size, unsigned n, FILE *fp);
FILE *freopen(char *filename, char *mode, FILE *oldfile);
int	  fseek	 (FILE *fp, long offset, int whence);
long  ftell	 (FILE *fp);
int	  fwrite (void *ptr, unsigned size, unsigned n, FILE *fp);
char *gets	 (char *s);
void  perror (char *s);
int	  puts	 (char *s);
int	  rename (char *oldname, char *newname);
void  rewind (FILE *fp);
void  setbuf (FILE *fp, void *buf);
int	  setvbuf(FILE *stream, void *buf, int type, unsigned size);
char *strerror(char *string);
int	  ungetc (int c, FILE *fp);

int	 fprintf (FILE *fp, char *format, ...);
int	 printf	 (char *format, ...);
int	 sprintf (char *buffer, char *format, ...);
int	 vfprintf(FILE *fp, char *format, va_list arglist);
int	 vprintf (char *format, va_list arglist);
int	 vsprintf(char *buffer, char *format, va_list arglist);

int	 fscanf	 (FILE *fp, char *format, ...);
int	 scanf	 (char *format, ...);
int	 sscanf	 (char *buffer, char *format, ...);
int	 vfscanf (FILE *fp, char *format, va_list arglist);
int	 vscanf	 (char *format, va_list arglist);
int	 vsscanf (char *buffer, char *format, va_list arglist);
void cwin_exit( int r );

/*	The following macros provide for common functions */

#define ferror(f)	((f)->flags & _IOERR)
#define feof(f)		((f)->flags & _IOEOF)
#define fileno(f)	((f)->fd)
#define remove(filename) unlink(filename)


#ifdef __NO_STDIO_INLINE__

#define getc fgetc
#define putc fputc

#else

#define getc(fp) \
    ((fp)->curp < (fp)->eofp ? (*(fp)->curp++) : fgetc (fp))

#define putc(c, fp) \
    ((fp)->curp < (fp)->endp ? (*(fp)->curp++ = (c)) : fputc ((c), (fp)))

#endif

#define getchar()  (fgetc (stdin))
#define putchar(c) (fputc ((c), stdout))
#define	exit(n)	   cwin_exit(n)



// stdlib.h̕⊮.

char *getenv(char *name);

// celib.cp.

int	 dosgetc(FILE *fp);		// CR 菜 fgetc()
void *xmalloc(int);
int isatty(int fileno);

//[EOF]
