/**********************************************************************
 *
 *		stdio.c ̂悤Ȃ́iShift-JIŜ݃T|[gj
 *
 *		S̓IɎ蔲ł.
 **********************************************************************
 */
//#define __NO_STDIO_INLINE__
#include "stdio.h"
#include "stat.h"
#include "conslib.h"

#define	MAX_FILES	16

#define	DEBUG	0
#define	TTY_FD	(-2)
int	errprintf(char *fmt,... );
/**********************************************************************
 *		
 **********************************************************************
typedef struct	{
	int     	flags;		// tOrbg          	       
	int 		fd;			// WinCẼt@Cnh         

	unsigned char *buffer;	// Xg[Eobt@            
	unsigned char *curp;	// [̓ǂݏ|C^    
	unsigned char *eofp;	// [̓ǂݍݎ|C^̍ŏIʒu 
	unsigned char *endp;	// [̏ݎ|C^̍ŏIʒu 
	int 		bsize;		// Xg[Eobt@̊mۃTCY         
	int			level;		// Xg[Eobt@̎gpoCg       

	char  		token;		// FILE\̂gpȂ...1      
	char  		istty;		// TTY INȂ1 OUTȂ2 t@C=0 
	char		hold;		// ungetc()pz[hobt@      
}	FILE;
 *
 *	FILE̊Ǘ@:
 *		fopen() buffer[bsize]mۂ.(malloc)
 *		curp = eofp = endp = buffer ɂĂ.
 *
 *		getc()̓}NŎ.	curp < eofp ̏ꍇ getc = (*curp++);
 *		curp  eofp ɒBAfgetc_fillbuf(fp)ĂяoāAobt@
 *		ɗ߂. ܂obt@̏I[ʒu eofp ɃZbg.
 *
 *		putc()}NŎ.   curp < endp ̏ꍇ (*curp++)=c;
 *		curp  endp ɒBAfflush(fp)ĂяoāAobt@o.
 *
 *		fseek()Ƃ́Afflush(fp)sāA჌xseeksȂA
 *		curp = eofp = endp = buffer ɂĂ.
 *
 *		getc()putc()݂Ƃ́AԂfflush()Afseek()܂
 *		Γ͕ۏ؂ȂB
 *
 *	_IOLBF   eofp = endp = buffer ƂāAfputc()ɗ悤ɂ
 *	fputc() *curp++ = c;sB curp  buffer + bsize -1 ɓB
 *	A'\n'ꂽ̂݁AR\[ɓfoB
 *
 *	_IONBF ̓T|[gȂB
 *
 *		s\risjŁAGetch()𔭍sꍇ͖Ifflush()
 *		KvƂȂ.
 *
 *
 */

FILE _streams[MAX_FILES];	// [0] stdin ,[1] stdout ,[2] stderr


/**********************************************************************
 *		󂢂Ă _streams[] T.
 **********************************************************************
 */
static FILE *new_streams(void)
{
	int i;
	FILE *f;
	for(i=3;i<MAX_FILES;i++) {
		f = &_streams[i];
		if(f->token==0) return f;
	}
	return NULL;
}

/**********************************************************************
 *		
 **********************************************************************
 */
void *xmalloc(int size)
{
	void *p;
	p = malloc(size);
	if(p==NULL) {
		errprintf("Memory exhaust!\n");
		exit(1);
	}
	return p;
}
/**********************************************************************
 *		_stream \̂ttyo͗pɏ.
 **********************************************************************
 */
static void set_stream(FILE *f,int flag)
{
	f->token  = 1;
	f->istty  = flag;
	f->level  = 0;
	f->fd     = TTY_FD;
	f->bsize  = BUFSIZ;
	f->buffer = xmalloc( f->bsize );
	f->curp   = f->buffer;
	f->endp   = f->buffer;
	f->eofp   = f->buffer;
	f->flags  = flag;
}

static void chk_fp(FILE *f)
{
	unsigned int fd = f - _streams;
	if(fd >= MAX_FILES) {
		errprintf("celib.c: Internal Error . *fp = %x\n",f);exit(1);
	}
}

/**********************************************************************
 *		_streams[] ̏.
 **********************************************************************
 */
void celib_init(void)
{
	int i;
	FILE *f;

	for(i=0;i<MAX_FILES;i++) {
		f = &_streams[i];
		f->token  = 0;
		f->istty  = 0;
		f->flags  = 0;
		f->level  = 0;

		f->bsize  = 0;
		f->buffer = NULL;
		f->curp   = NULL;
		f->endp   = NULL;
		f->eofp   = NULL;
	}
	
	set_stream(stdin ,_IOREAD |_IOLBF);
	set_stream(stdout,_IOWRITE|_IOLBF);
	set_stream(stderr,_IOWRITE|_IOLBF);

}

/**********************************************************************
 *		
 **********************************************************************
 */
int sjis2TCHAR( char *src, TCHAR *dst, int max )
{
	return MultiByteToWideChar( CP_ACP, 0, src, -1, dst, max )<<1 ;
}

/**********************************************************************
 *		蔲 printf()n.
 **********************************************************************
 */

int	vsprintf(char *buf, char *fmt, va_list arglist);

int	errprintf(char *fmt,... )
{
	char  buf[1024];
	TCHAR Tbuf[1024];
	va_list	 va_ptr;
	int ret;

	va_start( va_ptr, fmt ) ;
		ret = vsprintf(buf,fmt,va_ptr);
		sjis2TCHAR( buf,Tbuf,1020 );
		Cputs( Tbuf );
	va_end( va_ptr );
	return ret;
}

/**********************************************************************
 *		r-ihrp:Pڔ.
 **********************************************************************
 */
static int iskanji1(int c)
{
	if ((c>=0x81)&&(c<0xa0)) return 1;
	if ((c>=0xe0)&&(c<0xfc)) return 1;
	return 0;
}

#if	0
/**********************************************************************
 *		r-ihrp:o.
 **********************************************************************
 */
static void conout(int c,FILE *f)
{
	char  buf[32];
	TCHAR Tbuf[32];

	c &= 0xff;
	if(	f->hold ) {	//S-JISQڂ̏.
		buf[0]=f->hold;
		buf[1]=c;
		buf[2]=0;

		sjis2TCHAR( buf,Tbuf,16 );
		Cputs( Tbuf );
		f->hold = 0;
	}else{
		if(iskanji1(c)) {	//S-JIS Pڂ̏.
			f->hold = c;
		}else{
			Tbuf[0]=c;
			Tbuf[1]=0;
			Cputs( Tbuf );
		}
	}
}
#endif
/**********************************************************************
 *		}NA`
 **********************************************************************
 */
static	char	*vp;
static	void vputc(int c)
{
	*vp++ = c;
}

static	int is_num(int c)
{
	if((c<'0')||(c>'9')) return(-1);
	return(c-'0');
}

/**********************************************************************
 *		oB
 **********************************************************************
 */
static char *getnum(char *s,int *val)
{
	int v,r,sgn;
	v=0;
	sgn=1;
	
	if(*s=='-') {s++;sgn=(-1);}
	
	if(is_num(*s)>=0) {
	   while( (r=is_num(*s)) >=0) {
		v*=10;
		v+=r;
		s++;
	   }
	   *val=v*sgn;
	}
	return(s);
}

/**********************************************************************
 *		Tu[`
 **********************************************************************
 */
static	int hexch(int c,int alp)
{
	if(c>=10)	 c += alp;	/* 'A''a'  */
				 c += '0';
	return(c);
}

static	void hexprint(int val,int column,int radix,int fmt,int filler)
{
	static char hexbuf[32];
	int i,minus=0;
	int alp;
	
	if(fmt=='x') alp=0x27;
	else		 alp=0x07;

	if(radix==10) {
		if(val < 0) {val = -val ; minus=1;}
	}

	i=0;
	do {
		hexbuf[i++] = hexch( (unsigned) val %  radix,alp);
		   			         (unsigned) val /= radix;
	}while(val!=0);

	if(minus && (filler=='0') ) {
		vputc('-');
		while(column>(i+1)) {
			vputc(filler);column--;
		}
	}else{
		if(minus) hexbuf[i++]='-';
		while(column>i) {
			vputc(filler);column--;
		}
	}
	
	while(i>0) {
		vputc(hexbuf[--i]);
	}
}

static	void strprint(char *s,int column)
{
	int	l;
	int slen;
	slen=strlen(s);

	/* ]KvȂ */
	if(   column > slen ) {
		l=column - slen;
		while(l) {
			vputc(' ');l--;
		}
	}

	while(*s) {
		vputc(*s++);
	}

	/* E]KvȂ */
	if( column<0 ) {
	if(   (-column) > slen ) {
		l=(-column) - slen;
		while(l) {
			vputc(' ');l--;
		}
	}
	}
}

static	void chrprint(int c)
{
	vputc(c);
}

/**********************************************************************
 *		ij
 **********************************************************************
 */
int	vsprintf(char *buf , char *fmt , va_list ap)
{
	int  column;
	int  c,filler;
	
	vp=buf;
	
	while(*fmt) {
		if(*fmt=='%') {					/* GXP[v */
			column=1;
			if(fmt[1]=='0') filler='0';
			else		    filler=' ';

			fmt=getnum(fmt+1,&column);	/* ̌̐ => column */
 
 			c = *fmt++;
 			if(c=='l') {
 					c = *fmt++;
 			}
			switch(c) {
			  case 'd':
			  case 'D':
			  	hexprint(  va_arg (ap, int) ,column,10,c,filler );break;
			  case 'x':
			  case 'X':
			  	hexprint(  va_arg (ap, int) ,column,16,c,filler );break;
			  case 's':
			  	strprint(  va_arg (ap, char *),column);	   break;
			  case 'c':
			  	chrprint(  va_arg (ap, int) );			   break;
#if	0
			  case 'f':
			  case 'F':
			  case 'g':
			  case 'G':
				dblprint( ap,c );
#endif
			  case '%':
			  	chrprint( '%' );			   break;
			  default:
			  	break;
			}
		}else{
			if(*fmt == '\n') 
				vputc( '\r');	/* lr-cnr̎dl(CR+LF)Ɉ˂ */
			vputc(*fmt++);
		}
	}
	vputc(0);
	return( vp - buf );		/* o͂Ԃ */
}

/**********************************************************************
 *		
 **********************************************************************
 */
int	 printf(char *format, ...)
{
	char _prbuf[1024];
	int i,l;
    va_list ap;

    va_start (ap, format);
	i = vsprintf(_prbuf,format,ap);
    va_end (ap);
    
	l=strlen(_prbuf);
	fwrite(_prbuf,1,l,stdout);
	return i;
}
/**********************************************************************
 *		
 **********************************************************************
 */
#if	1	// Ȃ񂩂ub{{Ă܂IȂ("%s\n",s)݂Ȉ
		// X^bNt[Ɏc炸ɃWX^ɏ܂܂łB
		// ǁAprintf͂ƓĂ̂ŁAub{{̋C܂ꂩ???.
int	 fprintf(FILE *fp, char *format, int arg1 , int arg2 , ...)
{
	char _prbuf[1024];	//݂܂蔲ł.
	int i,l;
    va_list ap;

	i = (int) &arg1;	//AhXQƂ鎖ŖWX^A[h.
	l = (int) &arg2;

    va_start (ap, format);
	i = vsprintf(_prbuf,format,ap);
    va_end (ap);

	l=strlen(_prbuf);
	fwrite(_prbuf,1,l,fp);
	return i;
}
#else

//͂ub{{oOĂȂΐƎv镁ʂ̏.
int	 fprintf(FILE *fp, char *format, ...)
{
	char _prbuf[1024];
	int i,l;
    va_list ap;

    va_start (ap, format);
	i = vsprintf(_prbuf,format,ap);
    va_end (ap);

	l=strlen(_prbuf);
	fwrite(_prbuf,1,l,fp);
	return i;
}
#endif
/**********************************************************************
 *		
 **********************************************************************
 */
static char *convpath(char *t,const char *s)
{
	char *r = t;
	while(*s) {
		if(*s =='/' ) *t++ = '\\';
		else *t++ = *s;
		
		s++;
	}
	*t=0;
	return r;
}
/**********************************************************************
 *		
 **********************************************************************
 */
static FILE *fopen_r(const char *filename, char *mode,FILE *f)
{
	int createf=OPEN_EXISTING;
	int writef =GENERIC_READ;
	int flags  =0;
	char name[256];
	TCHAR tbuf[256];
	TCHAR abuf[256];
	
	switch( mode[0] ) {
	 case 'r':		flags =(_IOREAD);
	 				writef =GENERIC_READ ;createf=OPEN_EXISTING;	break;
	 case 'w':
	 case 'a':		flags =(_IOWRITE);
	 				writef =GENERIC_WRITE;createf=CREATE_ALWAYS;	break;
	  default:		return NULL;
	}
	switch( mode[1]) {
	 case '+':		flags|=(_IOUPD);
	 				writef =GENERIC_READ|GENERIC_WRITE;	break;
	 default:		break;
	}

	sjis2TCHAR( convpath(name,filename) ,tbuf,510 );
	rel2absdir( abuf,256,tbuf );

#if	DEBUG
	errprintf("feopn: CreateFile: writef=%d createf=%d\n",writef,createf);
	
	errprintf("tbuf=[");
	Cputs(tbuf);
	errprintf("]\nabuf=[");
	Cputs(abuf);
	errprintf("]\n");
#endif

	f->fd = (int)CreateFile( abuf, writef, FILE_SHARE_READ, NULL,
						 		   createf,FILE_ATTRIBUTE_NORMAL, 0 ) ;

#if	DEBUG
	errprintf("feopn: CreateFile=%d:\n",f->fd);
#endif

	if ( (HANDLE)f->fd == INVALID_HANDLE_VALUE ) {
#if	DEBUG
		errprintf("feopn: CreateFile ERR\n");
#endif
		return NULL ;
	}
	if ( mode[0]=='w' ) {	SetEndOfFile(   (HANDLE)f->fd ); }
	if ( mode[0]=='a' ) {	SetFilePointer( (HANDLE)f->fd, 0, NULL, FILE_END ); }
	
	f->token = 1;
	f->flags = flags;
	f->istty = 0;
	f->level = 0;

	f->bsize  = BUFSIZ;
	f->buffer = xmalloc( f->bsize );
	f->curp   = f->buffer;
	f->endp   = f->buffer;
	f->eofp   = f->buffer;

	return f;
}

/**********************************************************************
 *		
 **********************************************************************
 */
FILE *freopen(char *filename, char *mode, FILE *fp)
{
	return fopen_r(filename, mode, fp);
}

/**********************************************************************
 *		
 **********************************************************************
 */
FILE *fopen(const char *filename, char *mode)
{
	FILE *fp;
	fp = new_streams();if(fp==NULL) return NULL;
	return fopen_r(filename, mode, fp);
}
/**********************************************************************
 *		
 **********************************************************************
 */
FILE *set_redirect(FILE *fp,char *filename,char *mode)
{
	return fopen_r(filename, mode, fp);
}
/**********************************************************************
 *		
 **********************************************************************
 */
char *fgets(char *buf, int n, FILE *fp)
{
	int  c;
	char *s=buf;

	while ((c = getc(fp)) != '\n') {
		if (n == 0) break;

		if (c == EOF) {
			if (s == buf) {
				return NULL;
			}else{
				break;
			}
		}else{
			*s++ = c;
		}
		n--;
	}
	*s = 0;
	return buf;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int	 sprintf(char *buffer, char *format, ...)
{
	int ret;
	va_list	 va_ptr;

	va_start( va_ptr, format ) ;
	ret = vsprintf(buffer,format,va_ptr);
	va_end( va_ptr );
	return ret;
}

/**********************************************************************
 *		
 **********************************************************************
 */
int	 puts(char *s)
{
	while(*s) putchar(*s++);
	putchar('\n');
	return  '\n';
}

/**********************************************************************
 *		
 **********************************************************************
 */
int	  fwrite(void *ptr, unsigned size, unsigned n, FILE *fp)
{
	unsigned int len;
	char *s = ptr;
	
	len = size * n;
	while(len != 0) {
		putc(*s,fp);s++;len--;
	}
	return size * n;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int	  fread(void *ptr, unsigned size, unsigned n, FILE *fp)
{
	unsigned int len;
	char *s = ptr;
	
	len = size * n;
	while(len != 0) {
		*s++ = getc(fp);len--;
	}
	return size * n;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int	 fflush(FILE *f)
{
	DWORD donesize=0;

#if	DEBUG
	if(f->buffer)
		errprintf("fflush(%x) 1 level=%d\n",f->flags,f->level);
#endif

	if( (f->flags & _IOWRITE) && ((f->flags & _IOBMASK) == _IOFBF) )  {
		if(f->buffer!= f->endp) {		//obt@Of[^?
			f->level = f->curp - f->buffer;	//ݗĂoCg.
			if(f->level) {
				WriteFile( (HANDLE)f->fd, f->buffer , f->level , &donesize , NULL ) ;
				if((int)donesize != f->level) return EOF;	// FAIL.
#if	DEBUG
				errprintf("fflush(%x) 2\n",f->flags);
#endif
				f->curp  = f->buffer;	//݃|C^߂.
				f->level = 0;
				f->endp  = f->buffer;
				f->eofp  = f->buffer;
			}
		}
	}
	return 0;	// Success
}
/**********************************************************************
 *		
 **********************************************************************
 */
#define	C_(n) ((n)-0x40)

int	 _fputc_flsh(char c, FILE *f)
{
	int brk;

	chk_fp(f);
	if(!(f->flags & _IOWRITE)) return EOF;

	if(f->buffer) {		//obt@O.
		if((f->flags & _IOBMASK) == _IOFBF) {

			if( fflush(f) == EOF ) return EOF;

			f->endp  = f->buffer + f->bsize;//Xg[obt@eʕ̃|C^݂.
			*f->curp++ = c;					//̕(c)P.
			return c;
		}else{			//sobt@O.(R\[)
			TCHAR Tbuf[BUFSIZ];

			*f->curp++ = c; f->level++;		//Ɉ̕(c)P.
			if( (c=='\n') || (f->curp >= (f->buffer + f->bsize - 1) ) )
			{	//sbobt@tɂȂ,
				{
					*f->curp = 0;
					sjis2TCHAR( f->buffer,Tbuf,BUFSIZ );
					Cputs( Tbuf );
				}
				f->curp  = f->buffer;		//|C^߂.
				f->level = 0;

#if	1	//o͒ ^C  ^S ̎󂯕t.
				if( Kbhit() ) {
					brk = Getch();
					if(brk == C_('S')) {	// ^S󂯂AɂP҂.
						brk = Getch();
					}
					if(brk == C_('C')) exit(11);	// ^C Ȃ甲.
				}
#endif

			}
		}
	}else{				//obt@OȂ.(ڃR\[)
#if	0
		if(f->istty == 2) {
			conout(c,f);
			return c;
		}
#endif
	}
	return EOF;			//s.
}
/**********************************************************************
 *		
 **********************************************************************
 */
int	 fclose(FILE *f)
{
#if	DEBUG
	errprintf("fclose(%d) 1\n",f->flags);
#endif

	if( (f!=NULL) && (f->token==1) && ((HANDLE)f->fd != INVALID_HANDLE_VALUE)) {

#if	DEBUG
		errprintf("fclose(%d) 2\n",f->flags);
#endif
		fflush(f);

		CloseHandle( (HANDLE)f->fd );
		f->token = 0;
		if(f->buffer) {
			free(f->buffer);
			f->buffer = NULL;
		}
	}
	return 0;
}

/**********************************************************************
 *		
 **********************************************************************
 */
int	 _fgetc_fill(FILE *f)
{
	DWORD donesize;
	BOOL  r;
	
	chk_fp(f);

	if(f->flags & _IOEOF) return EOF;
	if(!(f->flags & _IOREAD)) return EOF;

	fflush(f);
	if(f->buffer) {
		r = ReadFile( (HANDLE)f->fd, f->buffer , f->bsize , &donesize , NULL ) ;
		if( !r || (donesize==0) ) {
			f->flags |= _IOEOF;
			return EOF;
		}
		f->curp  = f->buffer;
		f->level = f->bsize;
		if( (int)donesize != f->bsize ) f->level = donesize;

		f->endp  = f->buffer;
		f->eofp  = f->buffer + f->level;

		return  *f->curp++;
	}else{
		return Getch();		//Ή!
	}
	return EOF;
}

/**********************************************************************
 *		
 **********************************************************************
 */
int fgetc(FILE *f)
{
#if	DEBUG
	chk_fp(f);
#endif

	if( f->curp < f->eofp ) {
		return *f->curp ++;
	}else{
		return _fgetc_fill(f);
	}
}
/**********************************************************************
 *		
 **********************************************************************
 */
int fputc(char c,FILE *f)
{
#if	DEBUG
	chk_fp(f);
#endif

	if( f->curp < f->endp ) {
		*f->curp ++ = c;
		return c;
	}else{
		return _fputc_flsh(c,f);
	}
}
int dosgetc(FILE *f)
{
	int c;
	c=fgetc(f);
	if(	c=='\r') {	// CR 폜.
		c=fgetc(f);
	}
	return c;
}
/**********************************************************************
 *		malloc[ɃRs[Ã|C^Ԃ
 **********************************************************************
 */
char *xstrdup(char *string)
{
    return (char *) strcpy(xmalloc (strlen (string) + 1), string);
}

static DWORD unicode2sjis( LPCTSTR src, BYTE *dst, DWORD max )
{
	return WideCharToMultiByte( CP_ACP, 0, src, -1, dst, dst ? max : 0, NULL, NULL ) ;
}
static char *u2a(TCHAR *src)
{
	static char u2abuf[256+1];
	unicode2sjis( src,u2abuf,256 );
	return u2abuf;
}
/**********************************************************************
 *		
 **********************************************************************
 */
char *getenv(char *name)
{
	TCHAR Tname[256+1];
	TCHAR Tval[256+1];
	int r;
	
	sjis2TCHAR(name,Tname,256);
	r = GetEnvVar(Tname,Tval,256);
	if(r) {
		return u2a(Tval);
	}
	return NULL;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int  fstat(int handle, struct stat *statbuf)
{
	BY_HANDLE_FILE_INFORMATION info;

	if ( GetFileInformationByHandle((HANDLE) handle, &info) == TRUE) {
		statbuf->st_size = info.nFileSizeLow;
		return 0;
	}
	return -1;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int  stat(const char *path, struct stat *statbuf)
{
	FILE *fp;
	int rc;
	fp = fopen(path,"rt");
	if(fp==NULL) return -1;
	rc = fstat(fp->fd,statbuf);
	fclose(fp);
	return rc;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int isatty(int fileno)
{
    return ( fileno == TTY_FD );
}
int fseek (FILE *fp, long offset, int whence)
{
    /* Xg[tbV */
    if (fflush (fp) < 0)
	return -1;
	
	if((fp->flags & _IOBMASK)!=_IOFBF) return -1;

    /* ۂ seek  */
	if( SetFilePointer((HANDLE)fp->fd,offset,0,whence) == (-1) ) return -1;
	
    /* I[wqNA */
    fp->flags &= ~_IOEOF;

    /*  */
    return 0;
}